Subject: Re: [Roll] New Version Notification for draft-ietf-roll-unaware-leaves-10.txt

From: Rahul Jadhav <[email-masked]>
Date: Sun, 17 May 2020 02:22:33 +0000

Hi Pascal,

Revisiting this thread because of some new light [1].

Question is, Can an RPL node in Storing MOP send a DAO with Transit Info Option with Parent Address subfield?

Previously, you pointed out RFC6550 section 9.8 which clearly mentions that "Parent Address in Storing MOP MUST be empty".

However, as per Section 9.4, the RFC says, "In order to inject such a (external) Target in the RPL network, the router MUST advertise itself as the DODAG Parent Address subfield in the Transit..."

Essentially Section 9.4 contradicts 9.8 both using MUST clauses.

Just for the record, this discussion does not have any impact on the unaware-leaves draft.

Best,
Rahul

[1] new light: Rabi actually informed me about section 9.8 in context to another offline discussion wrt Storing-Root-Ack.
________________________________
From: Pascal Thubert (pthubert) <[email-masked]>
Sent: 13 March 2020 12:49 AM
To: Rahul Jadhav <[email-masked]>; Routing Over Low power and Lossy networks <[email-masked]>
Subject: RE: New Version Notification for draft-ietf-roll-unaware-leaves-10.txt

Hello Rahul

RFC 6550 says:

“

9.8<https://tools.ietf.org/html/rfc6550#section-9.8>.  Storing Mode

   In Storing mode, RPL routes messages Downward by the IPv6 destination

   address.  The following rules apply to nodes that are in Storing

   mode:

   1.  The DODAG Parent Address subfield of a Transmit Information

       option MUST be empty.

“

So even if it is a good idea it requires new specs to override RFC 6550.

More below (using P2>)

From: Rahul Jadhav <[email-masked]>
Sent: jeudi 12 mars 2020 16:32
To: Pascal Thubert (pthubert) <[email-masked]>; Routing Over Low power and Lossy networks <[email-masked]>
Subject: Re: New Version Notification for draft-ietf-roll-unaware-leaves-10.txt

Please find below inline answers. Also, I did not get any objection from 6lo so I added a IANA section that reduces the EARO status range to 0-63, which solves the issue you raised.

[RJ] Yep, that indeed takes care of a major point ??. Please find my [RJ] responses inline.

Regarding this statement,

"Non-Storing Mode DAO messages are used to signal external routes to
   the Root, even if the DODAG is operated in Storing Mode."

I couldn't find any text which provides reasoning to do so. Why non-storing mode DAO is needed and why storing mode DAO won't work?

Pascal> We need the address of the 6LR to terminate the tunnel and remove the artifacts, and the NS signaling will give us that. This is how we removed the hassle of hop by hop link local tunnels that was in the old useofrplinfo.

There is this text which says, "The Non-Storing Mode DAO messaging enables to advertise the 6LR that serves the RUL and injects the route to the Root." This can be achieved even with storing mode DAO with the target as RUL address and transit information containing parent address as anchor 6LR address.

Pascal > Which is not the normal storing mode signaling.

[RJ] Yes, but 6550 does not stop us from doing it. Interestingly, I have a use-case in my deployment wherein I need to send this parent address info even in storing MOP. It helps the root get the complete network graph even in storing mode for visualization purposes (if the admin wants to check how the network is formed, how many hops etc on the root in storing mode).

P2> It does actually, see above

It would be an hybrid. The cool thing with NS is that the external prefixes are not visible inside the RPL domain. Legacy nodes do not have to know they exist. Only the 6LR at the border that inject the external routes and the Root are aware and need to know about the new signaling. Using an hybrid impacts every node.

[RJ] The hybrid may not necessarily impact every node. An intermediate 6LR may decide to ignore that external target in the DAO and that would still be ok. In this case, the signaling will work through next common ancestor which has to capability to hold/process that kind of info.

P2> which is still an impact; new code to recognize the ‘E’ flag and decide to ignore the address. A legacy node would not do the right thing.

Trying to understand the reason because this mode of signaling has implications (already covered in the draft), particularly that, when the DAG is operating in storing mode, the communication to RUL from other RANs would mandatorily have to be routed through root only. If we use storing mode DAO then this could be optimized. Not sure if I am missing anything?

Pascal > Well, yes, we could have done that as well. The path could be optimized but

*  it would mean that the common parent has to encapsulate to the 6LR, which is an additional function there

* It would also mean that the network has ot be aware of external routes, which may be too many for the SM tables.

[RJ] I am just keen on doing this because it makes things flexible. Anchor 6LR has both options of sending NS-DAO or storing DAO. Intermediate 6LRs also have both options, honor the external target info or ignore it and just pass it on.

P2> I’m happy to discuss it and see if and how we open RPL in that direction. But for short term we’re shipping useofrplinfo and RUL with the low hanging fruit.

Pros and cons I guess. We went for the simple and backward compatible way.

[RJ] Yes, Backward compatibility may be an issue because intermediate 6LRs operating in pure storing mode will try to cache the external target and may not be able to do IP-in-IP at their point. However, handling this compatibility may not be a big challenge. The flexibility this provides is very compelling to me. With DAO projection, we have already entered that zone where the nodes could be hybrid in nature.

PT2> with the capability work we’ll be able to introduce this and more : )

Take care,

Pascal

________________________________

From: Roll <[email-masked]<mailto:[email-masked]>> on behalf of Pascal Thubert (pthubert) <pthubert=[email-masked]<mailto:pthubert=[email-masked]>>
Sent: 12 March 2020 07:38 PM
To: Routing Over Low power and Lossy networks <[email-masked]<mailto:[email-masked]>>
Subject: [Roll] FW: New Version Notification for draft-ietf-roll-unaware-leaves-10.txt

Dear all

As discussed with the IOT DIR, this draft is not the gating factor for all cluster C310.
In order to progress I made a full pass on it and fixed a few bugs and misalignments with useofrplinfo.

I believe the doc is ripe for WGLC.

Many thanks

Pascal

-----Original Message-----
From: [email-masked]<mailto:[email-masked]> <[email-masked]<mailto:[email-masked]>>
Sent: jeudi 12 mars 2020 15:04
To: Michael Richardson <[email-masked]<mailto:[email-masked]>>; Michael C. Richardson <[email-masked]<mailto:[email-masked]>>; Pascal Thubert (pthubert) <[email-masked]<mailto:[email-masked]>>
Subject: New Version Notification for draft-ietf-roll-unaware-leaves-10.txt

A new version of I-D, draft-ietf-roll-unaware-leaves-10.txt
has been successfully submitted by Pascal Thubert and posted to the IETF repository.

Name:           draft-ietf-roll-unaware-leaves
Revision:       10
Title:          Routing for RPL Leaves
Document date:  2020-03-12
Group:          roll
Pages:          32
URL:            https://www.ietf.org/internet-drafts/draft-ietf-roll-unaware-leaves-10.txt
Status:         https://datatracker.ietf.org/doc/draft-ietf-roll-unaware-leaves/
Htmlized:       https://tools.ietf.org/html/draft-ietf-roll-unaware-leaves-10<https://tools.ietf..org/html/draft-ietf-roll-unaware-leaves-10>
Htmlized:       https://datatracker.ietf.org/doc/html/draft-ietf-roll-unaware-leaves
Diff:           https://www.ietf.org/rfcdiff?url2=draft-ietf-roll-unaware-leaves-10

Abstract:
   This specification extends RFC6550 and RFC8505 to provide unicast and
   multicast routing services in a RPL domain to 6LNs that are plain
   Hosts and do not participate to RPL, and enables the RPL Root to
   proxy the EDAR/EDAC flow on behalf of the RULs and RANs in its DODAG.

Please note that it may take a couple of minutes from the time of submission until the htmlized version and diff are available at tools.ietf.org.

The IETF Secretariat

_______________________________________________
Roll mailing list
[email-masked]<mailto:[email-masked]>
https://www.ietf.org/mailman/listinfo/roll

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Mon, 18 May 2020 11:30:46 +0000

Hello Rahul:

The short answer is that because we introduce non-storing signaling at the edge of a storing mode DODAG.
You may see it as an extension outside of the RPL domain that is covered by the rule you pointed out.
See https://tools.ietf.org/html/draft-ietf-roll-useofrplinfo-38#section-4.1
“
   This specification updates [RFC6550<https://tools.ietf.org/html/rfc6550>] to RECOMMEND that external
   targets are advertised using Non-Storing Mode DAO messaging even in a
   Storing-Mode network.

“
Is that your answer?

Take care,

Pascal

From: Rahul Jadhav <[email-masked]>
Sent: dimanche 17 mai 2020 04:23
To: Pascal Thubert (pthubert) <[email-masked]>; Routing Over Low power and Lossy networks <[email-masked]>; rabi narayan sahoo <[email-masked]>
Subject: Re: New Version Notification for draft-ietf-roll-unaware-leaves-10.txt

Hi Pascal,

Best,
Rahul

[1] new light: Rabi actually informed me about section 9.8 in context to another offline discussion wrt Storing-Root-Ack.
________________________________
From: Pascal Thubert (pthubert) <[email-masked]<mailto:[email-masked]>>
Sent: 13 March 2020 12:49 AM
To: Rahul Jadhav <[email-masked]<mailto:[email-masked]>>; Routing Over Low power and Lossy networks <[email-masked]<mailto:[email-masked]>>
Subject: RE: New Version Notification for draft-ietf-roll-unaware-leaves-10.txt

Hello Rahul

RFC 6550 says:

“

   mode:

       option MUST be empty.

“

More below (using P2>)

From: Rahul Jadhav <[email-masked]<mailto:[email-masked]>>
Sent: jeudi 12 mars 2020 16:32
To: Pascal Thubert (pthubert) <[email-masked]<mailto:[email-masked]>>; Routing Over Low power and Lossy networks <[email-masked]<mailto:[email-masked]>>
Subject: Re: New Version Notification for draft-ietf-roll-unaware-leaves-10.txt

[RJ] Yep, that indeed takes care of a major point 😊. Please find my [RJ] responses inline.

Take care,

Pascal

Dear all

Many thanks

Pascal

-----Original Message-----
From: [email-masked]<mailto:[email-masked]> <[email-masked]<mailto:[email-masked]>>
Sent: jeudi 12 mars 2020 15:04
To: Michael Richardson <[email-masked]<mailto:[email-masked]>>; Michael C. Richardson <[email-masked]<mailto:[email-masked]>>; Pascal Thubert (pthubert) <[email-masked]<mailto:[email-masked]>>
Subject: New Version Notification for draft-ietf-roll-unaware-leaves-10.txt

Abstract:

The IETF Secretariat

---

From: Rahul Jadhav <[email-masked]>
Date: Mon, 18 May 2020 12:03:28 +0000

So even in storing MOP a 6LN/6LR should use non-storing MOP signaling to send the external routes to the root. I guess this is what is done in unaware-leaves as well.

This does answer my question. Many Thanks.

For storing-root-ack, Rabi pointed out a case where the 6LN/6LR sends DAO on behalf of the unware-RPL node and we were wondering if we could make use of parent address in storing MOP to signal the root about this external node. I guess even in that case we can refer to unaware-leaves/useofrplinfo rationale and send DAO for external targets directly to the root to keep the handling consistent (and minimal changes).

Thanks,
Rahul
________________________________
From: Pascal Thubert (pthubert) <[email-masked]>
Sent: 18 May 2020 07:30 PM
To: Rahul Jadhav <[email-masked]>; Routing Over Low power and Lossy networks <[email-masked]>; rabi narayan sahoo <[email-masked]>
Subject: RE: New Version Notification for draft-ietf-roll-unaware-leaves-10.txt

Hello Rahul:

“

   Storing-Mode network.

“

Is that your answer?

Take care,

Pascal

Hi Pascal,

Best,

Rahul

Hello Rahul

RFC 6550 says:

“

   mode:

       option MUST be empty.

“

More below (using P2>)

Take care,

Pascal

Dear all

Many thanks

Pascal

-----Original Message-----
From: [email-masked]<mailto:[email-masked]> <[email-masked]<mailto:[email-masked]>>
Sent: jeudi 12 mars 2020 15:04
To: Michael Richardson <[email-masked]<mailto:[email-masked]>>; Michael C. Richardson <[email-masked]<mailto:[email-masked]>>; Pascal Thubert (pthubert) <[email-masked]<mailto:[email-masked]>>
Subject: New Version Notification for draft-ietf-roll-unaware-leaves-10.txt

Abstract:

The IETF Secretariat

---

From: "Pascal Thubert (pthubert)" <[email-masked]>
Date: Wed, 20 May 2020 13:16:34 +0000

Hello Rahul

A very interesting comment.

Yes, the 6LR is expected to do what’s necessary to best serve the RPL unaware leaf.

The RUL is not aware of RPL so it cannot know whether the 6LR is doing storing-root-ack or even talking RPL at all for that matter.

What makes sense is that on the first registration, the 6LR (optionally) waits for the storing-root-ack before it sends the NA(EARO) back. This change of the flow would be indicated in your storing-root-ack draft.

Does that work?

Pascal

From: Rahul Jadhav <[email-masked]>
Sent: lundi 18 mai 2020 14:03
To: Pascal Thubert (pthubert) <[email-masked]>; Routing Over Low power and Lossy networks <[email-masked]>; rabi narayan sahoo <[email-masked]>
Subject: Re: New Version Notification for draft-ietf-roll-unaware-leaves-10.txt

Thanks,
Rahul
To: Rahul Jadhav <[email-masked]<mailto:[email-masked]>>; Routing Over Low power and Lossy networks <[email-masked]<mailto:[email-masked]>>; rabi narayan sahoo <[email-masked]<mailto:[email-masked]>>

Hello Rahul:

“

   Storing-Mode network.

“

Is that your answer?

Take care,

Pascal

From: Rahul Jadhav <[email-masked]<mailto:[email-masked]>>
Sent: dimanche 17 mai 2020 04:23
To: Pascal Thubert (pthubert) <[email-masked]<mailto:[email-masked]>>; Routing Over Low power and Lossy networks <[email-masked]<mailto:[email-masked]>>; rabi narayan sahoo <[email-masked]<mailto:[email-masked]>>
Subject: Re: New Version Notification for draft-ietf-roll-unaware-leaves-10.txt

Hi Pascal,

Best,

Rahul

Hello Rahul

RFC 6550 says:

“

   mode:

       option MUST be empty.

“

More below (using P2>)

Take care,

Pascal

Dear all

Many thanks

Pascal

-----Original Message-----
From: [email-masked]<mailto:[email-masked]> <[email-masked]<mailto:[email-masked]>>
Sent: jeudi 12 mars 2020 15:04
To: Michael Richardson <[email-masked]<mailto:[email-masked]>>; Michael C. Richardson <[email-masked]<mailto:[email-masked]>>; Pascal Thubert (pthubert) <[email-masked]<mailto:[email-masked]>>
Subject: New Version Notification for draft-ietf-roll-unaware-leaves-10.txt

Abstract:

The IETF Secretariat

---

From: Rahul Jadhav <[email-masked]>
Date: Thu, 21 May 2020 02:07:37 +0000

Yes, the storing-root-ack can clarify the change in flow for NA(EARO) for RULs.
Have raised an issue to follow-up on this:
https://github.com/nyrahul/roll-root-ack/issues/1

Thanks,
Rahul
Sent: 20 May 2020 09:16 PM

Hello Rahul

Does that work?

Pascal

Thanks,

Rahul

Hello Rahul:

“

   Storing-Mode network.

“

Is that your answer?

Take care,

Pascal

Hi Pascal,

Best,

Rahul

Hello Rahul

RFC 6550 says:

“

   mode:

       option MUST be empty.

“

More below (using P2>)

Take care,

Pascal

Dear all

Many thanks

Pascal

-----Original Message-----
From: [email-masked]<mailto:[email-masked]> <[email-masked]<mailto:[email-masked]>>
Sent: jeudi 12 mars 2020 15:04
To: Michael Richardson <[email-masked]<mailto:[email-masked]>>; Michael C. Richardson <[email-masked]<mailto:[email-masked]>>; Pascal Thubert (pthubert) <[email-masked]<mailto:[email-masked]>>
Subject: New Version Notification for draft-ietf-roll-unaware-leaves-10.txt

Abstract:

The IETF Secretariat